SystemOrganization addCategory: #'Git-Plumbing'!
SystemOrganization addCategory: #'Git-Tests'!

Object subclass: #GitDeltaInterpreter
	instanceVariableNames: 'source instructions output commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitDeltaInterpreter methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 12:01'!
instructions
	^ instructions! !

!GitDeltaInterpreter methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 12:01'!
instructions: anObject
	instructions := anObject! !

!GitDeltaInterpreter methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 12:09'!
readVariableInteger
	| val shift b |
	val := 0.
	shift := 0.
	[
		b := commands next.
		val := val bitOr: ((b bitAnd: 127) bitShift: shift).
		shift := shift + 7.
	] doWhileFalse: [(b bitAnd: 128) isZero].
	^ val! !

!GitDeltaInterpreter methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 12:20'!
run
	[commands atEnd] whileFalse: [self runNextCommand]! !

!GitDeltaInterpreter methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 12:25'!
runAgainst: aByteArray
	source := aByteArray.
	
	commands := ReadStream on: instructions.
	source size = self readVariableInteger ifFalse: [self error: 'Delta source size mismatch'].
	output := WriteStream on: (ByteArray new: self readVariableInteger).
	self run.

	^ output contents! !

!GitDeltaInterpreter methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 12:19'!
runNextCommand
	| cmd |
	cmd := commands next.
	cmd = 0 ifTrue: [self error: 'unexpected delta opcode 0'].
	cmd < 128
		ifTrue: [output nextPutAll: (commands next: cmd)]
		ifFalse: [
			| off size |

			off := 0.
			(cmd bitAnd: 2r00000001) isZero ifFalse: [off := commands next].
			(cmd bitAnd: 2r00000010) isZero ifFalse: [off := off bitOr: (commands next bitShift: 8)].
			(cmd bitAnd: 2r00000100) isZero ifFalse: [off := off bitOr: (commands next bitShift: 16)].
			(cmd bitAnd: 2r00001000) isZero ifFalse: [off := off bitOr: (commands next bitShift: 24)].

			size := 0.
			(cmd bitAnd: 2r00010000) isZero ifFalse: [size := commands next].
			(cmd bitAnd: 2r00100000) isZero ifFalse: [size := size bitOr: (commands next bitShift: 8)].
			(cmd bitAnd: 2r01000000) isZero ifFalse: [size := size bitOr: (commands next bitShift: 16)].
			size = 0 ifTrue: [size := 16r10000].
			
			output nextPutAll: (source copyFrom: off + 1 to: off + size)]! !

Object subclass: #GitObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

GitObject subclass: #GitBlob
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitBlob class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 16:02'!
bytes: aByteArray
	^ self new initializeBytes: aByteArray asByteArray! !

!GitBlob class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 07:19'!
typeCode
	^ 'blob'! !

!GitBlob methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 07:59'!
bytes
	^ bytes! !

!GitBlob methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 13:31'!
initializeBytes: aByteArray
	bytes := aByteArray! !

!GitBlob methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 08:00'!
loadFrom: aStream
	bytes := aStream contents.! !

!GitBlob methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 15:36'!
saveTo: aStream
	aStream nextPutAll: bytes.! !

!GitObject class methodsFor: 'private' stamp: 'MaxLeske 4/17/2010 12:59'!
forType: aString  
 ^ self allSubclasses
       detect: [ :class | aString isNil not & class typeCode = aString ]
       ifNone: [ self error: 'Invalid type code: ' , aString printString ]! !

!GitObject class methodsFor: 'accessing' stamp: 'MaxLeske 4/17/2010 13:41'!
loadFrom: aStream
	| code length limitedStream |
	code := (aStream upTo: Character space asInteger) asString.
	length := (aStream upTo: 0) asString asInteger. "? why 0? why double conversion?"
	limitedStream := ReadStream on: (aStream next: length).
	^ (self forType: code) new loadFrom: limitedStream! !

!GitObject class methodsFor: 'private' stamp: 'tonyg 2/25/2010 17:04'!
typeCode
	"Override in subclasses, returning non-nil where you want them to be constructible from a git oject store."
	^ nil! !

!GitObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 07:39'!
loadFrom: aStream
	self subclassResponsibility! !

!GitObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 15:35'!
saveTo: aStream
	self subclassResponsibility! !

!GitObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 15:47'!
typeCode
	^ self class typeCode! !

GitObject subclass: #GitTaglikeObject
	instanceVariableNames: 'message properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

GitTaglikeObject subclass: #GitCommit
	instanceVariableNames: 'tree parents author committer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitCommit class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 22:21'!
typeCode
	^ 'commit'! !

!GitCommit class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 22:06'!
withDefaultStamps
	| s |
	s := GitStamp now.
	^ self new author: s; committer: s! !

!GitCommit methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:54'!
author
	^ author! !

!GitCommit methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:54'!
author: anObject
	author := anObject! !

!GitCommit methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:54'!
committer
	^ committer! !

!GitCommit methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:54'!
committer: anObject
	committer := anObject! !

!GitCommit methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:23'!
loadKey: k value: v
	k = 'tree' ifTrue: [tree := GitObjectNameLiteral sha1String: v. ^ self].
	k = 'parent' ifTrue: [
		parents ifNil: [parents := OrderedCollection new].
		parents add: (GitObjectNameLiteral sha1String: v).
		^ self].
	k = 'author' ifTrue: [author := GitStamp fromString: v. ^ self].
	k = 'committer' ifTrue: [committer := GitStamp fromString: v. ^ self].
	"Otherwise it's treated generically."
	^ super loadKey: k value: v! !

!GitCommit methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 21:54'!
parents
	^ parents ifNil: [#()]! !

!GitCommit methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:54'!
parents: anObject
	^ parents := anObject! !

!GitCommit methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:27'!
saveFixedKeysTo: aStream
	"Looking at builtin-commit-tree.c, the order of properties is fixed:
	tree, parents, author, committer, everything else, message."
	self saveKey: 'tree' value: tree sha1String to: aStream.
	self parents do: [:p | self saveKey: 'parent' value: p sha1String to: aStream].
	self saveKey: 'author' value: author printString to: aStream.
	self saveKey: 'committer' value: committer printString to: aStream.! !

!GitCommit methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 21:53'!
tree
	^ tree! !

!GitCommit methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:54'!
tree: anObject
	tree := anObject! !

!GitCommit methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:34'!
validate
	tree ifNil: [self error: 'Cannot have a commit without a tree.'].
	author ifNil: [self error: 'Author identity is required.'].
	committer ifNil: [self error: 'Committer identity is required.'].
	super validate.! !

GitTaglikeObject subclass: #GitTag
	instanceVariableNames: 'objectName objectTypeCode tagName tagger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitTag class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:39'!
named: tagName on: objectName typeCode: typeCode message: message
	^ self named: tagName on: objectName typeCode: typeCode message: message tagger: GitStamp now! !

!GitTag class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:39'!
named: tagName on: objectName typeCode: typeCode message: message tagger: aGitStamp
	^ self new
		tagName: tagName;
		objectName: objectName;
		objectTypeCode: typeCode;
		message: message;
		tagger: aGitStamp! !

!GitTag class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:16'!
typeCode
	^ 'tag'! !

!GitTag methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:32'!
loadKey: k value: v
	k = 'object' ifTrue: [objectName := GitObjectNameLiteral sha1String: v. ^ self].
	k = 'type' ifTrue: [objectTypeCode := v. ^ self].
	k = 'tag' ifTrue: [tagName := v. ^ self].
	k = 'tagger' ifTrue: [tagger := GitStamp fromString: v. ^ self].
	"Otherwise it's treated generically."
	^ super loadKey: k value: v! !

!GitTag methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:30'!
objectName
	^ objectName! !

!GitTag methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:30'!
objectName: anObject
	objectName := anObject! !

!GitTag methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:31'!
objectTypeCode
	^ objectTypeCode! !

!GitTag methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:31'!
objectTypeCode: anObject
	objectTypeCode := anObject! !

!GitTag methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:36'!
saveFixedKeysTo: aStream
	"From builtin-mktag.c:
	A signature file has a very simple fixed format: four lines
	of ""object <sha1>"" + ""type <typename>"" + ""tag <tagname>"" +
	""tagger <committer>"", followed by a blank line, a free-form tag
	message and a signature block that git itself doesn't care about,
	but that can be verified with gpg or similar."
	self saveKey: 'object' value: objectName sha1String to: aStream.
	self saveKey: 'type' value: (objectTypeCode ifNil: [objectName retrieveObject typeCode]) to: aStream.
	self saveKey: 'tag' value: tagName to: aStream.
	self saveKey: 'tagger' value: tagger printString to: aStream.! !

!GitTag methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:30'!
tagName
	^ tagName! !

!GitTag methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:30'!
tagName: anObject
	tagName := anObject! !

!GitTag methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:30'!
tagger
	^ tagger! !

!GitTag methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:30'!
tagger: anObject
	tagger := anObject! !

!GitTag methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:34'!
validate
	objectName ifNil: [self error: 'Cannot have a tag without a tagged object.'].
	tagName ifNil: [self error: 'Tag name is required.'].
	tagger ifNil: [self error: 'Tagger identity is required.'].
	super validate.! !

!GitTaglikeObject methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/17/2010 11:58'!
loadFrom: aStream
	| key value |
	[aStream peek = Character lf asInteger] whileFalse: [
		key := (aStream upTo: Character space asInteger) asString.
		value := (aStream upTo: Character lf asInteger) asString.
		self loadKey: key value: value].
	aStream next.
	message := aStream upToEnd asString.
! !

!GitTaglikeObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:23'!
loadKey: k value: v
	self properties add: k -> v.! !

!GitTaglikeObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:22'!
message
	^ message! !

!GitTaglikeObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:22'!
message: aString
	message := aString! !

!GitTaglikeObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:22'!
properties
	^ properties ifNil: [properties := OrderedCollection new]! !

!GitTaglikeObject methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:23'!
properties: anObject
	^ properties := anObject! !

!GitTaglikeObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:27'!
saveFixedKeysTo: aStream
	self subclassResponsibility! !

!GitTaglikeObject methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/17/2010 12:04'!
saveKey: key value: value to: aStream
	aStream 
		nextPutAll: key asByteArray; nextPut: Character space asInteger; 
		nextPutAll: value asByteArray; nextPut: Character lf asInteger.! !

!GitTaglikeObject methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/17/2010 11:59'!
saveTo: aStream
	self validate.
	self saveFixedKeysTo: aStream.
	properties ifNotNil: [properties do: [:assoc |
			self saveKey: assoc key value: assoc value to: aStream]].
	aStream nextPut: Character lf asInteger.
	aStream nextPutAll: message asByteArray.! !

!GitTaglikeObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/25/2010 16:34'!
validate
	"Override in subclasses to provide pre-save validation checks.
	Don't forget to call super validate, though!!"
	message ifNil: [self error: 'Message is required.'].! !

GitObject subclass: #GitTree
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitTree class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 19:15'!
entries: aCollection
	| t |
	t := self new.
	aCollection do: [:each | t putEntry: each].
	^ t! !

!GitTree class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 07:17'!
typeCode
	^ 'tree'! !

!GitTree methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 19:10'!
at: aName
	^ (self entryAt: aName) object! !

!GitTree methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 19:15'!
entries
	^ entries! !

!GitTree methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 19:10'!
entryAt: aName
	^ entries at: aName! !

!GitTree methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 20:18'!
initialize
	super initialize.
	entries := Dictionary new.! !

!GitTree methodsFor: 'as yet unclassified' stamp: 'MaxLeske 3/30/2010 16:48'!
loadFrom: aStream
	| e |
	[aStream atEnd] whileFalse: [
		e := GitTreeEntry new loadFrom: aStream.
		self putEntry: e]! !

!GitTree methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 19:11'!
putEntry: anEntry
	entries at: anEntry fileName put: anEntry! !

!GitTree methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 19:14'!
removeEntryAt: aFileName
	entries removeKey: aFileName! !

!GitTree methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 15:41'!
saveTo: aStream
	entries valuesDo: [:e | e saveTo: aStream].! !

Object subclass: #GitObjectName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitObjectName methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 06:45'!
resolve
	self subclassResponsibility! !

!GitObjectName methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 14:31'!
retrieveObject
	^ GitRepositoryCache instance objectAt: self! !

GitObjectName subclass: #GitObjectNameLiteral
	instanceVariableNames: 'sha1String'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitObjectNameLiteral class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 20:10'!
loadFrom: aStream
	^ self loadFromInteger: (aStream next: 20) asInteger! !

!GitObjectNameLiteral class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 16:05'!
loadFromInteger: h
	^ self sha1String: ((h printStringBase: 16) asLowercase forceTo: 40 paddingStartWith: $0)! !

!GitObjectNameLiteral class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 06:45'!
sha1String: aString
	^ self new sha1String: aString! !

!GitObjectNameLiteral methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 07:09'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(; nextPutAll: sha1String; nextPut: $).! !

!GitObjectNameLiteral methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 06:45'!
resolve
	^ sha1String! !

!GitObjectNameLiteral methodsFor: 'accessing' stamp: 'tonyg 2/24/2010 01:03'!
saveTo: aStream
	| h dl |
	h := Integer readFrom: (ReadStream on: sha1String asUppercase) base: 16.
	dl := h digitLength.
	20 to: dl + 1 by: -1 do: [:digitIndex | aStream nextPut: 0].
	dl to: 1 by: -1 do: [:digitIndex | aStream nextPut: (h digitAt: digitIndex)].
! !

!GitObjectNameLiteral methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 06:44'!
sha1String
	^ sha1String! !

!GitObjectNameLiteral methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 06:44'!
sha1String: anObject
	sha1String := anObject! !

GitObjectName subclass: #GitObjectNameRef
	instanceVariableNames: 'repo name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitObjectNameRef class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 13:01'!
repo: r name: n
	^ self new initializeRepo: r name: n! !

!GitObjectNameRef methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 13:01'!
initializeRepo: r name: n
	repo := r.
	name := n.! !

!GitObjectNameRef methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 13:02'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(; nextPutAll: repo printString; nextPutAll: ', '; nextPutAll: name; nextPut: $).! !

!GitObjectNameRef methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 20:24'!
resolve
	^ (repo resolveRef: name) sha1String! !

Object subclass: #GitPack
	instanceVariableNames: 'idx basePath fanoutTable objectCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitPack methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 15:42'!
basePath
	^ basePath! !

!GitPack methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 22:31'!
basePath: aString
	basePath := aString.
	idx := FileStream readOnlyFileNamed: basePath, '.idx'.
	idx binary.
	((idx next: 8) = #(255 116 79 99 0 0 0 2) asByteArray)
		ifFalse: [self error: 'Bad pack index header'].
	fanoutTable := idx next: 1024. "256 4-byte big-endian entries."
	objectCount := self fanoutTableAt: 255.! !

!GitPack methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 22:43'!
crcAt: index
	"1024 fanout, 8 header, minus 4 for smalltalk's 1-based indexing"
	idx position: 1028 + (objectCount * 20) + (index * 4).
	^ (idx next: 4) asInteger.! !

!GitPack methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 22:31'!
fanoutTableAt: fanoutIndex
	^ fanoutTable unsignedLongAt: (fanoutIndex * 4) + 1 bigEndian: true.! !

!GitPack methodsFor: 'accessing' stamp: 'tonyg 2/24/2010 00:32'!
objectAt: sha1String
	| p |
	p := self packedObjectAt: sha1String.
	p ifNotNil: [^ p object].
	^ nil! !

!GitPack methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 10:50'!
offsetAt: index
	| o |
	"1024 fanout, 8 header. We're still using zero-based indexing here."
	idx position: 1032 + (objectCount * 24) + (index * 4).
	o := (idx next: 4) asInteger.
	(o >= 16r80000000)
		ifFalse: [^ o]
		ifTrue: [
			"the table offset is zero-based here because it comes from git, not smalltalk"
			idx position: 1032 + (objectCount * 28) + ((o bitAnd: 16r7FFFFFFF) * 8).
			^ (idx next: 8) asInteger]! !

!GitPack methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 19:56'!
packedObjectAt: sha1String
	| i o |
	i := self tableIndexForSha: sha1String.
	i ifNil: [^ nil].
	o := self offsetAt: i.
	^ self packedObjectAtOffset: o! !

!GitPack methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 19:56'!
packedObjectAtOffset: offset 
	| p c |
	p := FileStream readOnlyFileNamed: basePath , '.pack'.
	p binary.
	p position: offset.
	c := GitPackedObject new pack: self.
	c loadFrom: p.
	^ c! !

!GitPack methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 10:49'!
tableIndexForSha: s
	| fanoutIndex sNum index low high test |
	sNum := Integer readFrom: (ReadStream on: s asUppercase) base: 16.
	fanoutIndex := sNum bitShift: -152. "160 bit hash. We want the upper 8 bits."

	"We are searching using a zero-based index, since position: on the file is zero-based."
	low := (fanoutIndex > 0) ifTrue: [self fanoutTableAt: fanoutIndex - 1] ifFalse: [0].
	high := (self fanoutTableAt: fanoutIndex) - 1. "binary-search wants an inclusive range"

	[index := high + low // 2.
	low > high] whileFalse:[
		idx position: index * 20 + 1032. "256 * 4 for the fanoutTable, plus 8 for the header"
		test := (idx next: 20) asInteger.
		test = sNum 
			ifTrue:[^index]
			ifFalse:[sNum > test
				ifTrue: [low := index + 1]
				ifFalse: [high := index - 1]]].
	^ nil! !

Object subclass: #GitPackedObject
	instanceVariableNames: 'pack file decodeClass length headerPos unpackedBytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:09'!
applyDelta: delta to: base
	decodeClass := base decodeClass.
	unpackedBytes := delta runAgainst: base unpackedBytes.! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:09'!
decodeClass
	^ decodeClass! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:04'!
loadFrom: aStream
	| b type shift |
	file := aStream.
	headerPos := file position.
	b := file next.
	type := (b bitShift: -4) bitAnd: 7.
	length := b bitAnd: 15.
	shift := 4.
	[(b bitAnd: 128) isZero] whileFalse: [
		b := file next.
		length := length bitOr: ((b bitAnd: 127) bitShift: shift).
		shift := shift + 7].
	self unpackContentType: type.! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:10'!
object
	^ decodeClass new loadFrom: (ReadStream on: unpackedBytes)! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 11:05'!
pack
	^ pack! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 11:05'!
pack: anObject
	pack := anObject! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:07'!
readDelta
	^ GitDeltaInterpreter new instructions: (ZLibReadStream on: file) contents.! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:04'!
unpackContentType: type
	type = 1 "OBJ_COMMIT" ifTrue: [decodeClass := GitCommit. ^ self unpackSimpleContent].
	type = 2 "OBJ_TREE" ifTrue: [decodeClass := GitTree. ^ self unpackSimpleContent].
	type = 3 "OBJ_BLOB" ifTrue: [decodeClass := GitBlob. ^ self unpackSimpleContent].
	type = 4 "OBJ_TAG" ifTrue: [self error: 'Packed tags aren''t supported yet.'].
	type = 6 "OBJ_OFS_DELTA" ifTrue: [^ self unpackOfsDeltaContent].
	type = 7 "OBJ_REF_DELTA" ifTrue: [^ self unpackRefDeltaContent].
	self error: 'Invalid pack object type ', type printString.! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:07'!
unpackOfsDeltaContent
	| offset b base delta |
	b := file next.
	offset := b bitAnd: 127.
	[(b bitAnd: 128) isZero] whileFalse: [
		b := file next.
		"This is bizarre, but it's what pack-format.txt and the Git source says is happening."
		offset := ((offset + 1) bitShift: 7) bitOr: (b bitAnd: 127)].

	delta := self readDelta.
	base := pack packedObjectAtOffset: headerPos - offset.
	self applyDelta: delta to: base.! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:08'!
unpackRefDeltaContent
	| s delta base |
	s := (GitObjectNameLiteral loadFrom: file) resolve.
	delta := self readDelta.
	base := pack packedObjectAt: s.
	self applyDelta: delta to: base.! !

!GitPackedObject methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 20:05'!
unpackSimpleContent 
	unpackedBytes := (ZLibReadStream on: file) contents.! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:09'!
unpackedBytes
	^ unpackedBytes! !

Object subclass: #GitRepository
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitRepository commentStamp: 'MaxLeske 4/2/2010 10:59' prior: 0!
A GitRepository is xxxxxxxxx.

Instance Variables
	reference:		<Object>

reference
	I'm an instance of FSReference. I know where the repository is located and on what file system
!

!GitRepository class methodsFor: 'initialize-release' stamp: 'MaxLeske 4/13/2010 15:11'!
new
	self error: 'This class should be istantiated with a memory type.'! !

!GitRepository class methodsFor: 'initialize-release' stamp: 'MaxLeske 4/20/2010 17:51'!
on: aFilesystem
	| isClass |
	isClass := (aFilesystem isKindOf: Class).
	isClass ifTrue: [self error: 'Please provide an instance of a filesystem, not a class.'].
	^self basicNew initializeOn: aFilesystem
	! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/2/2010 12:01'!
delete
	self reference delete! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/2/2010 12:02'!
exists
	^self reference exists! !

!GitRepository methodsFor: 'accessing' stamp: 'MaxLeske 4/13/2010 16:14'!
gitInitializeWithName: aString
	| repoDir |
	reference := reference resolve: aString.	"make reference point to specified directory"
	repoDir := reference.
	reference exists
		ifFalse: [ 
			reference createDirectory.
			#('objects' 
			'objects/pack' 
			'objects/info' 
			'refs' 'refs/heads' 
			'refs/tags' 
			'info') do: [ :each | (reference / each) createDirectory ].
			
			reference := repoDir.
			(reference / 'HEAD') exists
				ifFalse: [ 
					reference / 'HEAD' writeStreamDo: [ 
						:stream | stream nextPutAll: 'ref: refs/heads/master'; nextPut: Character lf
					]
				] 
		]! !

!GitRepository methodsFor: 'initialize-release' stamp: 'MaxLeske 4/20/2010 17:37'!
initializeOn: aFilesystem
	reference := aFilesystem working! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 10:54'!
looseObjectBytesAt: name 
	^ (self looseObjectStreamAt: name) contents! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 10:55'!
looseObjectNames
	| r |
	r := OrderedCollection new.
	self looseObjectNamesDo: [ :n | r add: n ].
	^ r! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'MaxLeske 3/30/2010 16:51'!
looseObjectNamesDo: aBlock 
	| root dir |
	root := self directory directoryNamed: 'objects'.
	root directoryNames do: 
		[ :dirName | 
		dirName size = 2 ifTrue: 
			[ dir := root directoryNamed: dirName.
			dir fileNames do: [ :fileName | aBlock value: (GitObjectNameLiteral sha1String: dirName , fileName) ] ] ]! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 10:55'!
looseObjectPathFor: name 
	| s |
	s := name resolve.
	^ 'objects/' , (s first: 2) , '/' , (s allButFirst: 2)! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 19:46'!
looseObjectStreamAt: name 
	| deflatedFile |
	deflatedFile := self directory readOnlyFileNamed: (self looseObjectPathFor: name).
	^ ZLibReadStream on: deflatedFile binary! !

!GitRepository methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:45'!
makeTag: aGitTag
	^ self makeTagNamed: aGitTag tagName on: (self storeObject: aGitTag)! !

!GitRepository methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:45'!
makeTagNamed: tagName on: objectName
	^ self updateRef: 'refs/tags/', tagName to: objectName! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 10:54'!
objectAt: name 
	^ [ GitObject loadFrom: (self looseObjectStreamAt: name) ] 
		on: FileDoesNotExistException
		do: [ :ex | ex return: (self packedObjectAt: name) ]! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 10:35'!
packedObjectAt: name
	| s o |
	s := name resolve.
	self packsDo: [:p |
		o := p objectAt: s.
		o ifNotNil: [^ o]].
	^ nil! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'MaxLeske 3/30/2010 16:52'!
packedRefs
	| f d s n |
	f := self directory oldFileOrNoneNamed: 'packed-refs'.
	f ifNil: [^ nil].
	
	d := Dictionary new.
	[f atEnd] whileFalse: [
		f peek = $#
			ifTrue: [f upTo: Character lf]
			ifFalse: [
				s := f upTo: Character space.
				n := f upTo: Character lf.
				d at: n put: (GitObjectNameLiteral sha1String: s)]].
	f close.
	^ d! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'MaxLeske 3/30/2010 16:58'!
packsDo: aBlock
	| d temp |
	d := self directory directoryNamed: 'objects/pack'.
	d fileNames do: [:n |
		(n endsWith: '.idx') ifTrue: [
			temp := n allButLast: 4.
			aBlock value: (GitPack new basePath: (d fullNameFor: temp))]]! !

!GitRepository methodsFor: 'accessing' stamp: 'MaxLeske 4/2/2010 11:39'!
reference
	^reference! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'tonyg 2/24/2010 00:25'!
resolveLooseRef: refPath
	| target |
	target := [(self directory readOnlyFileNamed: refPath) contents]
		on: FileDoesNotExistException do: [:ex | ^ nil].
	(target startsWith: 'ref:') ifTrue: [^ self resolveRef: (target allButFirst: 4) withBlanksTrimmed].
	^ GitObjectNameLiteral sha1String: target substrings first "Ignore other junk after the hash."! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'tonyg 2/24/2010 00:31'!
resolveRef: name
"From the git-rev-parse manpage:
            1. if $GIT_DIR/<name> exists, that is what you mean (this is usually useful only for HEAD, FETCH_HEAD, ORIG_HEAD and MERGE_HEAD);
            2. otherwise, $GIT_DIR/refs/<name> if exists;
            3. otherwise, $GIT_DIR/refs/tags/<name> if exists;
            4. otherwise, $GIT_DIR/refs/heads/<name> if exists;
            5. otherwise, $GIT_DIR/refs/remotes/<name> if exists;
            6. otherwise, $GIT_DIR/refs/remotes/<name>/HEAD if exists."
	| fullName havePackedRefs packedRefs result |
	havePackedRefs := false.
	packedRefs := nil.
	#(
		''.
		'refs/'.
		'refs/tags/'.
		'refs/heads/'.
		'refs/remotes/'.
		"We don't do the last case (number 6) from the manual yet."
	) do: [:prefix |
		fullName := prefix, name.
		result := self resolveLooseRef: fullName.
		result ifNotNil: [^ result].
		havePackedRefs ifFalse: [packedRefs := self packedRefs. havePackedRefs := true].
		packedRefs ifNotNil: [
			result := packedRefs at: fullName ifAbsent: [nil].
			result ifNotNil: [^ result]]].
	^ nil! !

!GitRepository methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 19:09'!
storeLooseObject: o
	| s m body objectBytes name |
	s := WriteStream on: (ByteArray new).
	o saveTo: s.
	body := s contents.
	
	m := WriteStream on: (ByteArray new).
	m
		nextPutAll: o typeCode asByteArray; nextPut: 32;
		nextPutAll: body size printString asByteArray; nextPut: 0;
		nextPutAll: body.
	objectBytes := m contents.
	
	name := GitObjectNameLiteral loadFromInteger:
				(SecureHashAlgorithm new hashMessage: objectBytes).
	self storeLooseObjectBytes: objectBytes at: name.
	^ name! !

!GitRepository methodsFor: 'accessing' stamp: 'MaxLeske 4/2/2010 15:52'!
storeLooseObjectBytes: aByteArray at: name
	| z compressed objectPathReference |
	z := ZLibWriteStream on: (ByteArray new).
	z nextPutAll: aByteArray; close.
	compressed := z encodedStream contents.
	
	objectPathReference := self reference resolve: (self looseObjectPathFor: name).
	objectPathReference parent ensureDirectory.
	objectPathReference writeStreamDo: [ :stream | stream nextPutAll: compressed ]! !

!GitRepository methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:43'!
storeObject: o
	^ self storeLooseObject: o! !

!GitRepository methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/13/2010 16:14'!
updateRef: refPath to: objectName
	| target pathReference |
	target := [(self reference resolve: refPath) readStreamDo: [ :stream | stream contents ]]
		on: FSFileDoesNotExist do: [:ex | ex return: nil].

	(target isNil not and: [target beginsWith: 'ref:']) ifTrue: [
		^ self updateRef: (target allButFirst: 4) withBlanksTrimmed to: objectName].

	pathReference := self reference resolve: refPath.
	pathReference parent ensureDirectory.
	pathReference writeStreamDo: [ 
		:stream | stream truncate; nextPutAll: objectName resolve; nextPut: Character lf
	].

	^ objectName! !

Object subclass: #GitRepositoryCache
	instanceVariableNames: 'repos mutex'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitRepositoryCache class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 08:17'!
instance
	^ Instance ifNil: [Instance := self new]! !

!GitRepositoryCache methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 14:38'!
addRepository: repo
	mutex critical: [
		(repos includes: repo)
			ifFalse: [repos add: repo]]! !

!GitRepositoryCache methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 14:38'!
initialize
	super initialize.
	repos := OrderedCollection new.
	mutex := Mutex new.! !

!GitRepositoryCache methodsFor: 'as yet unclassified' stamp: 'MaxLeske 3/30/2010 16:53'!
objectAt: objectName
	| resolved i held o repo |
	mutex critical: [
		repos isEmpty ifTrue: [^ nil].
		resolved := GitObjectNameLiteral sha1String: objectName resolve.
		i := 1.
		held := repos at: 1.
		[i > repos size] whileFalse: [
			repo := repos at: i.
			repos at: i put: held.
			o := repo objectAt: resolved.
			o ifNotNil: [
				repos at: 1 put: repo.
				^ o].
			i := i + 1.
			held := repo.].
		repos at: 1 put: held.
		^ nil.]! !

!GitRepositoryCache methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 14:38'!
removeRepository: repo
	mutex critical: [
		repos remove: repo ifAbsent: []]! !

!GitRepositoryCache methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 14:39'!
repos
	mutex critical: [
		^ repos copy]! !

Object subclass: #GitStamp
	instanceVariableNames: 'name email timeStamp'
	classVariableNames: 'DefaultEmail DefaultName'
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitStamp class methodsFor: 'accessing' stamp: 'lr 4/13/2010 16:45'!
defaultEmail
	^ DefaultEmail! !

!GitStamp class methodsFor: 'accessing' stamp: 'lr 4/13/2010 16:20'!
defaultEmail: aString
	DefaultEmail := aString! !

!GitStamp class methodsFor: 'accessing' stamp: 'lr 4/13/2010 16:45'!
defaultName
	^ DefaultName! !

!GitStamp class methodsFor: 'accessing' stamp: 'lr 4/13/2010 16:21'!
defaultName: aString
	DefaultName := aString! !

!GitStamp class methodsFor: 'instance creation' stamp: 'tonyg 2/23/2010 21:29'!
fromString: aString
	^ self readFrom: (ReadStream on: aString)! !

!GitStamp class methodsFor: 'instance creation' stamp: 'lr 4/13/2010 16:50'!
now
	^ self new 
		name: self defaultName; 
		email: self defaultEmail;
		yourself! !

!GitStamp class methodsFor: 'instance creation' stamp: 'MaxLeske 3/30/2010 19:57'!
readFrom: aStream
	| n e s sign z now |
	n := (aStream upTo: $<) withBlanksTrimmed.
	e := (aStream upTo: $>) withBlanksTrimmed.
	aStream skipSeparators.
	s := Integer readFrom: aStream.
	aStream skipSeparators.
	sign := aStream next.
	('-+' includes: sign) ifFalse: [self error: 'Invalid timezone sign'].
	z := Integer readFrom: aStream.
	z := (z // 100) hours + (z \\ 100) minutes.
	sign = $- ifTrue: [z := z negated].
	
	^ self new
		name: n;
		email: e; 
		timeStamp: ((DateAndTime epoch + s seconds) utcOffset: z)! !

!GitStamp methodsFor: 'private' stamp: 'tonyg 2/23/2010 21:24'!
cleanUp: aString
	^ aString copyWithoutAll: '<>', String lf! !

!GitStamp methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:21'!
email
	^ email! !

!GitStamp methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:23'!
email: aString
	email := self cleanUp: aString! !

!GitStamp methodsFor: 'initialize-release' stamp: 'lr 4/13/2010 16:46'!
initialize
	super initialize.
	timeStamp := TimeStamp now! !

!GitStamp methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:22'!
name
	^ name! !

!GitStamp methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:23'!
name: aString
	name := self cleanUp: aString! !

!GitStamp methodsFor: 'printing' stamp: 'MaxLeske 3/30/2010 19:51'!
printOn: aStream
	| z |
	aStream
		nextPutAll: name; nextPutAll: ' <'; nextPutAll: email; nextPutAll: '> ';
		nextPutAll: (timeStamp - DateAndTime epoch) asSeconds printString;
		nextPut: Character space.
	z := timeStamp offset.
	z < Duration zero
		ifTrue: [aStream nextPut: $-. z := z negated]
		ifFalse: [aStream nextPut: $+].
	aStream
		nextPutAll: (z hours printString forceTo: 2 paddingWith: $0);
		nextPutAll: (z minutes printString forceTo: 2 paddingWith: $0).! !

!GitStamp methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:21'!
timeStamp
	^ timeStamp! !

!GitStamp methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 21:23'!
timeStamp: aDuration
	timeStamp := aDuration! !

Object subclass: #GitTreeEntry
	instanceVariableNames: 'fileName mode objectName'
	classVariableNames: 'TypecodeMap'
	poolDictionaries: ''
	category: 'Git-Plumbing'!

!GitTreeEntry class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 20:16'!
dirMode
	^ 8r040000! !

!GitTreeEntry class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 20:15'!
fileMode
	^ 8r100644! !

!GitTreeEntry class methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 19:17'!
fileName: aString mode: anInteger objectName: aName
	^ self new initializeFileName: aString mode: anInteger objectName: aName! !

!GitTreeEntry methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 08:08'!
fileName
	^ fileName! !

!GitTreeEntry methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 19:18'!
initializeFileName: aString mode: anInteger objectName: aName
	fileName := aString.
	mode := anInteger.
	objectName := aName.! !

!GitTreeEntry methodsFor: 'as yet unclassified' stamp: 'tonyg 2/22/2010 08:13'!
loadFrom: aStream
	mode := Integer readFrom: (ReadStream on: (aStream upTo: 32) asString) base: 8.
	fileName := (aStream upTo: 0) asString.
	objectName := GitObjectNameLiteral loadFrom: aStream.! !

!GitTreeEntry methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 08:08'!
mode
	^ mode! !

!GitTreeEntry methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 13:28'!
object
	^ objectName retrieveObject! !

!GitTreeEntry methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 08:08'!
objectName
	^ objectName! !

!GitTreeEntry methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 15:46'!
saveTo: aStream.
	aStream nextPutAll: (mode printStringBase: 8) asByteArray; nextPut: 32.
	aStream nextPutAll: fileName asByteArray; nextPut: 0.
	objectName saveTo: aStream.! !

TestCase subclass: #GitBasicTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Tests'!

!GitBasicTests methodsFor: 'as yet unclassified' stamp: 'tonyg 2/23/2010 21:43'!
testStampReading
	| str stamp |
	str := 'Tony Garnock-Jones <tonygarnockjones@gmail.com> 1266614121 +1300'.
	stamp := GitStamp fromString: str.
	self assert: str = stamp printString.! !

TestCase subclass: #GitObjectTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Tests'!

!GitObjectTests class methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:28'!
packageNamesUnderTest
	^#('Git')! !

!GitObjectTests methodsFor: 'helpers' stamp: 'MaxLeske 4/17/2010 13:42'!
buildStream! !

!GitObjectTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/17/2010 13:34'!
testForType
	GitObject allSubclasses do: [:each | each typeCode isNil 
		ifFalse: [self assert: [(GitObject forType: each typeCode) = each]]
		ifTrue: [self should: [(GitObject forType: each typeCode)] raise: Error]]! !

!GitObjectTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 16:38'!
testLoadFrom
	| stream |
	stream := self buildStream.
	self fail
	! !

TestCase subclass: #GitRepositoryClassTests
	instanceVariableNames: 'repository filesystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Tests'!

!GitRepositoryClassTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 17:28'!
testNew
	self should: [GitRepository new] raise: Error! !

!GitRepositoryClassTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:08'!
testOnClass
	self should: [GitRepository on: FSDiskFilesystem]
		raise: Error
		description: 'Please provide an instance of a filesystem, not a class.'.! !

!GitRepositoryClassTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:11'!
testOnDiskFilesystem
	filesystem := FSDiskFilesystem current.
	self assert: [(GitRepository on: filesystem) reference filesystem = filesystem]! !

!GitRepositoryClassTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:11'!
testOnMemoryFilesystem
	filesystem := FSMemoryFilesystem new.
	self assert: [(GitRepository on: filesystem) reference filesystem = filesystem]! !

TestCase subclass: #GitRepositoryTests
	instanceVariableNames: 'repository filesystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Git-Tests'!

!GitRepositoryTests methodsFor: 'helpers' stamp: 'MaxLeske 4/20/2010 18:25'!
defaultStamp
	| str |
	str := 'Tony Garnock-Jones <tonygarnockjones@gmail.com> 1266614121 +1300'.
	^GitStamp fromString: str! !

!GitRepositoryTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:36'!
setUp
	filesystem := FSMemoryFilesystem new.
	repository := GitRepository on: filesystem.
	repository gitInitializeWithName:  'gitTestRepository.git'! !

!GitRepositoryTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:24'!
testGitInitialize
	self assert: (repository reference / 'HEAD') exists.
	self assert: (repository reference / 'info') exists.
	self assert: (repository reference / 'objects') exists.
	self assert: (repository reference / 'objects/pack') exists.
	self assert: (repository reference / 'objects/info') exists.
	self assert: (repository reference / 'refs') exists.
	self assert: (repository reference / 'refs/heads') exists.
	self assert: (repository reference / 'refs/tags') exists! !

!GitRepositoryTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:25'!
testInitialCommit
	| blob tree commit str stamp |
	blob := repository storeObject: (GitBlob bytes: 'hello').
	tree := repository storeObject: (GitTree entries: {
		GitTreeEntry fileName: 'test' mode: GitTreeEntry fileMode objectName: blob}).
	commit := GitCommit new.
	commit author: self defaultStamp.
	commit committer: self defaultStamp.
	commit := repository storeObject: (commit tree: tree; message: 'First commit').
	repository makeTag: (GitTag named: 'tagtest' on: commit typeCode: GitCommit typeCode message: 'First tag').
	repository makeTagNamed: 'lighttag' on: commit.
	repository updateRef: 'HEAD' to: commit! !

!GitRepositoryTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:35'!
testInitializeOnDiskFilesystem
	filesystem := FSDiskFilesystem current.
	repository := GitRepository basicNew initializeOn: filesystem.
	self assert: [repository reference filesystem isKindOf: FSDiskFilesystem].
	self assert: [repository reference = filesystem working]! !

!GitRepositoryTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:23'!
testInitializeOnMemoryFilesystem
	filesystem := FSMemoryFilesystem new.
	repository := GitRepository basicNew initializeOn: filesystem.
	self assert: [repository reference filesystem isKindOf: FSMemoryFilesystem].
	self assert: [repository reference = filesystem working]! !

!GitRepositoryTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:25'!
testSetupDirectoryStructure
	self assert: (repository reference / 'HEAD') exists.
	self assert: (repository reference / 'info') exists.
	self assert: (repository reference / 'objects') exists.
	self assert: (repository reference / 'objects/pack') exists.
	self assert: (repository reference / 'objects/info') exists.
	self assert: (repository reference / 'refs') exists.
	self assert: (repository reference / 'refs/heads') exists.
	self assert: (repository reference / 'refs/tags') exists! !

!GitRepositoryTests methodsFor: 'as yet unclassified' stamp: 'MaxLeske 4/20/2010 18:25'!
testStoreBlob
	| blob |
	blob := repository storeObject: (GitBlob bytes: 'hello').
	
	self assert: blob sha1String = 'b6fc4c620b67d95f953a5c1c1230aaab5db5a1b0'! !
